local L = AceLibrary("AceLocale-2.2"):new("TradeskillInfoUIConfig")

L:RegisterTranslations("enUS", function() return {

	["Skill required"] = true,
	["Show skill required"] = true,
	["Combine cost"] = true,
	["Show combine cost"] = true,
	["Source"] = true,
	["Show source in tooltip"] = true,
	["Used in"] = true,
	["Show used in in tooltip"] = true,
	["Usable by"] = true,
	["Show who can use an item"] = true,
	["Known by"] = true,
	["Show known by in recipe tooltip"] = true,
	["Learnable by"] = true,
	["Show learnable by in recipe tooltip"] = true,
	["Will be learnable by"] = true,
	["Show will be learnable by in recipe tooltip"] = true,
	["Trainer reagents"] = true,
	["Show recipe reagents in tooltip at trainer"] = true,

	["Tradeskill Info Config"] = true,
	["TradeSkill Frame"] = true,
	["Item Tooltip"] = true,
	["Recipe Tooltip"] = true,
	["Trainer Frame"] = true,
	["OK"] = true,

} end )

L:RegisterTranslations("koKR", function() return {

	["Skill required"] = "요구 숙련도",
	["Show skill required"] = "요구 숙련도를 표시합니다",
	["Combine cost"] = "생산물 가치",
	["Show combine cost"] = "생산물의 가치를 표시합니다",
	["Source"] = "획득방법",
	["Show source in tooltip"] = "툴팁에 획득방법을 표시합니다",
	["Used in"] = "사용기술",
	["Show used in in tooltip"] = "툴팁에 사용기술을 표시합니다",
	["Usable by"] = "사용인",
	["Show who can use an item"] = "툴팁에 사용인을 표시합니다",
	["Known by"] = "습득자",
	["Show known by in recipe tooltip"] = "제조법의 툴팁에 습득자를 표시합니다",
	["Learnable by"] = "습득가능자",
	["Show learnable by in recipe tooltip"] = "제조법의 툴팁에 습득가능자를 표시합니다",
	["Will be learnable by"] = "습득예상자",
	["Show will be learnable by in recipe tooltip"] = "제조법의 툴팁에 습득예상자를 표시합니다",
	["Trainer reagents"] = "상급자창 재료",
	["Show recipe reagents in tooltip at trainer"] = "상급자창의 툴팁에 제조법의 재료를 표시합니다",

	["Tradeskill Info Config"] = "Tradeskill Info 설정",
	["TradeSkill Frame"] = "전문기술 창",
	["Item Tooltip"] = "아이템 툴팁",
	["Recipe Tooltip"] = "제조법 툴팁",
	["Trainer Frame"] = "상급자 창",
	["OK"] = "확인",

} end )

TSI_TSI_CONFIG = L["Tradeskill Info Config"]
TSI_FRAME = L["TradeSkill Frame"]
TSI_ITEM_TOOLTIP = L["Item Tooltip"]
TSI_RECIPE_TOOLTIP = L["Recipe Tooltip"]
TSI_TRAINER_FRAME = L["Trainer Frame"]
TSI_OK = L["OK"]

-- $Revision: 14240 $
TradeskillInfo.options = {};
TradeskillInfo.options.ConfigFrame = {}
TradeskillInfo.options.ConfigFrame[L["Skill required"]] = { index=1, tooltipText=L["Show skill required"], var="ShowSkillLevel"};
TradeskillInfo.options.ConfigFrame[L["Combine cost"]] = { index=2, tooltipText=L["Show combine cost"], var="ShowSkillProfit"};
TradeskillInfo.options.ConfigFrame[L["Source"]] = { index=3, tooltipText=L["Show source in tooltip"], var="TooltipSource"};
TradeskillInfo.options.ConfigFrame[L["Used in"]] = { index=4, tooltipText=L["Show used in in tooltip"], var="TooltipUsedIn"};
TradeskillInfo.options.ConfigFrame[L["Usable by"]] = { index=5, tooltipText=L["Show who can use an item"], var="TooltipUsableBy"};
TradeskillInfo.options.ConfigFrame[L["Known by"]] = { index=6, tooltipText=L["Show known by in recipe tooltip"], var="TooltipKnownBy"};
TradeskillInfo.options.ConfigFrame[L["Learnable by"]] = { index=7, tooltipText=L["Show learnable by in recipe tooltip"], var="TooltipLearnableBy"};
TradeskillInfo.options.ConfigFrame[L["Will be learnable by"]] = { index=8, tooltipText=L["Show will be learnable by in recipe tooltip"], var="TooltipAvailableTo"};
TradeskillInfo.options.ConfigFrame[L["Trainer reagents"]] = { index=9, tooltipText=L["Show recipe reagents in tooltip at trainer"], var="TrainerReagents"};
--TradeskillInfo.options.ConfigFrame[""] = { index=9, tooltipText="", var=""};

--	MoneyFormat = 3,
function TradeskillInfo:Config_Init()
	if oSkin and oSkin.applySkin then
		oSkin:applySkin(TradeskillInfoConfigFrame);
	end
end

function TradeskillInfo:Config_Show()
	ShowUIPanel(TradeskillInfoConfigFrame);
end

function TradeskillInfo:Config_Hide()
	HideUIPanel(TradeskillInfoConfigFrame);
end

function TradeskillInfo:ConfigFrame_OnShow()
	for key, value in pairs(self.options.ConfigFrame) do
		option = getglobal("TradeskillInfo_Option"..value.index);
		text = getglobal("TradeskillInfo_Option"..value.index.."Text");
		if (option) then
			text:SetText(key);
			option.var = value.var;
			option:SetChecked(self.db.profile[value.var]);
			if (value.tooltipText) then
				option.tooltipText = value.tooltipText;
			end
		end
	end
end

function TradeskillInfo:ConfigFrame_OnHide()
end

function TradeskillInfo:OptionsCheckButtonOnClick()
	self.db.profile[this.var] = this:GetChecked() or false;
end

function TradeskillInfo:OptionsRadioButtonOnClick()
end