local Compost = AceLibrary("Compost-2.0");
local L = AceLibrary("AceLocale-2.2"):new("TradeskillInfoUI")

L:RegisterTranslations("enUS", function() return {

	["Item not in local cache."] = true,
	["Click to try to update local cache."] = true,
	["Warning! You can be disconnected."] = true,

	["Availability"] = true,
	["Tradeskills"] = true,

	["Recipe: "] = true,
	["Known By: "] = true,
	["Learnable By: "] = true,
	["Will Be Learnable By: "] = true,

	["Player known"] = true,
	["Player can learn"] = true,
	["Player will be able to learn"] = true,
	["Alt known"] = true,
	["Alt can learn"] = true,
	["Alt will be able to learn"] = true,
	["Unavailable"] = true,

	["Neutral"] = true,
	["Alliance"] = true,
	["Horde"] = true,

	["Tradeskill Info"] = true,
	["Search"] = true,

} end )

L:RegisterTranslations("koKR", function() return {

	["Item not in local cache."] = "아이템이 캐시에 존재하지 않습니다.",
	["Click to try to update local cache."] = "캐시를 업데이트 하기 위해서 클릭해주세요.",
	["Warning! You can be disconnected."] = "경고! 접속이 종료될 수 있습니다.",

	["Availability"] = "분류",
	["Tradeskills"] = "전문기술",

	["Recipe: "] = "제조법: ",
	["Known By: "] = "습득자: ",
	["Learnable By: "] = "습득가능자: ",
	["Will Be Learnable By: "] = "습득예상자: ",

	["Player known"] = "이미 배운 조제법",
	["Player can learn"] = "배울 수 있는 조제법",
	["Player will be able to learn"] = "추후 배울 수 있는 조제법",
	["Alt known"] = "다른 캐릭터가 이미 배운 조제법",
	["Alt can learn"] = "다른 캐릭터가 배울 수 있는 조제법",
	["Alt will be able to learn"] = "다른 캐릭터가 추후 배울 수 있는 조제법",
	["Unavailable"] = "사용불가",

	["Neutral"] = "중립",
	["Alliance"] = "얼라이언스",
	["Horde"] = "호드",

	["Tradeskill Info"] = "Tradeskill Info",
	["Search"] = "검색",

} end )

TSI_TITLE = L["Tradeskill Info"]
TSI_SEARCH = L["Search"]

TradeskillInfoUI = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "AceHook-2.0")
TradeskillInfoUI.version = "0.9." .. string.sub("$Revision: 15345 $", 12, -3);
TradeskillInfoUI.date = string.sub("$Date: 2006-10-27 20:31:04 -0400 (Fri, 27 Oct 2006) $", 8, 17);
TradeskillInfoUI:RegisterDB("TradeskillInfoUIDB")
TradeskillInfoUI:RegisterDefaults('profile', { 
	tradeskills = {['A']=true,['B']=true,['D']=true,['E']=true,['L']=true,['T']=true,['W']=true,['X']=true,['Z']=true,['Y']=true,},
	expanded = {['A']=true,['B']=true,['D']=true,['E']=true,['L']=true,['T']=true,['W']=true,['X']=true,['Z']=true,['Y']=true,},
	availability = {true,true,true,false,false,false,false},
})

TradeskillInfoUI.cons = {};
TradeskillInfoUI.cons.skillsDisplayed = 16;
TradeskillInfoUI.cons.maxSkillReagents = 8;
TradeskillInfoUI.cons.skillHeight = 16;

--UIPanelWindows["TradeskillInfoFrame"] =	{ area = "right", pushable = 3 };

TradeskillInfoUI.vars = {};
TradeskillInfoUI.vars.selectionIndex = 2;
TradeskillInfoUI.vars.searchResult = {};
TradeskillInfoUI.vars.availability = {
	L["Player known"],
	L["Player can learn"],
	L["Player will be able to learn"],
	L["Alt known"],
	L["Alt can learn"],
	L["Alt will be able to learn"],
	L["Unavailable"],
};
TradeskillInfoUI.vars.faction = {
	L["Neutral"],
	L["Alliance"],
	L["Horde"],
};
-- 0123456789ABCDEF
-- 1  1   1   1   1
TradeskillInfoUI.vars.TradeSkillTypeColor = {
	["playerknown"] = { r = 1.00, g = 1.00, b = 1.00 }, -- ffffff
	["playerlearn"] = { r = 0.25, g = 1.00, b = 0.25 }, -- 33ff33
	["playerhigh"] = { r = 1.00, g = 0.75, b = 0.25 }, -- ff7733
--	["altknown"] = { r = 0.25, g = 1.00, b = 1.00 },
--	["altlearn"] = { r = 0.25, g = 0.50, b = 1.00 },
--	["althigh"] = { r = 1.00, g = 0.25, b = 0.50 },
	["altknown"] = { r = 0.75, g = 0.75, b = 0.75 },
	["altlearn"] = { r = 0.00, g = 0.75, b = 0.00 },
	["althigh"] = { r = 0.75, g = 0.50, b = 0.00 },
	["unavailable"] = { r = 1.00, g = 0.00, b = 0.00 },
	["header"]	= { r = 1.00, g = 0.82, b = 0 },
};

function TradeskillInfoUI:OnEnable()
	if oSkin and oSkin.applySkin then
		oSkin:applySkin(TradeskillInfoFrame);
	end
end

function TradeskillInfoUI:Frame_Show()
	CloseDropDownMenus();
	TradeskillInfoTradeskillsDropDown:Hide();
	TradeskillInfoTradeskillsDropDown:Show();
	TradeskillInfoAvailabilityDropDown:Hide();
	TradeskillInfoAvailabilityDropDown:Show();
	ShowUIPanel(TradeskillInfoFrame);

	if not self:IsEventRegistered("TradeskillInfo_Update") then self:RegisterEvent("TradeskillInfo_Update","OnTradeskillInfoUpdate") end
	
	FauxScrollFrame_SetOffset(TradeskillInfoListScrollFrame, 0);
	TradeskillInfoListScrollFrameScrollBar:SetMinMaxValues(0, 0); 
	TradeskillInfoListScrollFrameScrollBar:SetValue(0);
	TradeskillInfoUI:Search();
	TradeskillInfoUI:Frame_SetSelection(TradeskillInfoUI.vars.selectionIndex);
	TradeskillInfoUI.Frame_Update();
end

function TradeskillInfoUI:Frame_Hide()
	if self:IsEventRegistered("TradeskillInfo_Update") then self:UnregisterEvent("TradeskillInfo_Update") end
	HideUIPanel(TradeskillInfoFrame);
end

function TradeskillInfoUI:Frame_Toggle()
	if TradeskillInfoFrame:IsVisible() then
		TradeskillInfoUI:Frame_Hide()
	else
		TradeskillInfoUI:Frame_Show()
	end
end

function TradeskillInfoUI:OnTradeskillInfoUpdate()
	self:Search();
	local selectionIndex
	if self.vars.selectionIndex == 0 then
		selectionIndex = self:GetFirstTradeSkill();
	else
		selectionIndex = self.vars.selectionIndex;
	end
	if ( self.vars.selectionIndex > 1 and self.vars.selectionIndex <= self:GetNumTradeSkills() ) then
--		self:Print("OnTradeskillInfoUpdate 1)",selectionIndex,FauxScrollFrame_GetOffset(TradeskillInfoListScrollFrame));
		self:Frame_SetSelection(selectionIndex);
		if selectionIndex < FauxScrollFrame_GetOffset(TradeskillInfoListScrollFrame) then
			FauxScrollFrame_SetOffset(TradeskillInfoListScrollFrame, selectionIndex-1);
			TradeskillInfoListScrollFrameScrollBar:SetValue((selectionIndex-1)*TradeskillInfoUI.cons.skillHeight);
		elseif selectionIndex > (FauxScrollFrame_GetOffset(TradeskillInfoListScrollFrame) + TradeskillInfoUI.cons.skillsDisplayed) then
			FauxScrollFrame_SetOffset(TradeskillInfoListScrollFrame, selectionIndex-TradeskillInfoUI.cons.skillsDisplayed);
			TradeskillInfoListScrollFrameScrollBar:SetValue((selectionIndex-TradeskillInfoUI.cons.skillsDisplayed)*TradeskillInfoUI.cons.skillHeight);
		end
--		self:Print("OnTradeskillInfoUpdate 2)",selectionIndex,FauxScrollFrame_GetOffset(TradeskillInfoListScrollFrame));
	else
		FauxScrollFrame_SetOffset(TradeskillInfoListScrollFrame, 0);
		TradeskillInfoListScrollFrameScrollBar:SetValue(0);
	end
	self.Frame_Update();
end

----------------------------------------------------------------------
--- Draw Tradeskills List
----------------------------------------------------------------------
function TradeskillInfoUI.Frame_Update()
-- Draw frame with tradeskill info
	local self = TradeskillInfoUI;
	local numTradeSkills = self:GetNumTradeSkills();
	local skillOffset = FauxScrollFrame_GetOffset(TradeskillInfoListScrollFrame);
	if ( numTradeSkills == 0 ) then
		TradeskillInfoSkillName:Hide();
		TradeskillInfoSkillIcon:Hide();
		TradeskillInfoRequirementLabel:Hide();
		TradeskillInfoRequirementText:SetText("");
		TradeskillInfoDescription:SetText("");
		TradeskillInfoRecipe:SetText("");
		TradeskillInfoKnown:SetText("");
		TradeskillInfoCollapseAllButton:Disable();
		for i=1, TradeskillInfoUI.cons.maxSkillReagents, 1 do
			getglobal("TradeskillInfoReagent"..i):Hide();
		end
	else
		TradeskillInfoCollapseAllButton:Enable();
	end
	-- ScrollFrame update
	FauxScrollFrame_Update(TradeskillInfoListScrollFrame, numTradeSkills, TradeskillInfoUI.cons.skillsDisplayed, TradeskillInfoUI.cons.skillHeight, nil, nil, nil, TradeskillInfoHighlightFrame, 293, 316 );

	TradeskillInfoHighlightFrame:Hide();
	for i=1, TradeskillInfoUI.cons.skillsDisplayed, 1 do
		local skillIndex = i + skillOffset;
		local skillButton = getglobal("TradeskillInfoSkill"..i);
		if ( skillIndex <= numTradeSkills ) then	
			local skillName, skillType, isExpanded = self:GetTradeSkillInfo(skillIndex);
			skillType = self:GetTradeSkillAvailability(skillIndex);
			-- Set button widths if scrollbar is shown or hidden
			if ( TradeskillInfoListScrollFrame:IsVisible() ) then
				skillButton:SetWidth(293);
			else
				skillButton:SetWidth(323);
			end
			local color = self.vars.TradeSkillTypeColor[skillType];
			if ( color ) then
				skillButton:SetTextColor(color.r, color.g, color.b);
			end
			
			skillButton:SetID(skillIndex);
			skillButton:Show();
			-- Handle headers
			if ( skillType == "header" ) then
				skillButton:SetText(skillName);
				if ( isExpanded ) then
					skillButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
				else
					skillButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				end
				getglobal("TradeskillInfoSkill"..i.."Highlight"):SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight");
				getglobal("TradeskillInfoSkill"..i):UnlockHighlight();
			else
				if ( not skillName ) then
					return;
				end
				skillButton:SetNormalTexture("");
				getglobal("TradeskillInfoSkill"..i.."Highlight"):SetTexture("");
				skillButton:SetText(" "..skillName);
				
				-- Place the highlight and lock the highlight state
				if ( self.vars.selectionIndex == skillIndex ) then
					TradeskillInfoHighlightFrame:SetPoint("TOPLEFT", "TradeskillInfoSkill"..i, "TOPLEFT", 0, 0);
					TradeskillInfoHighlightFrame:Show();
					getglobal("TradeskillInfoSkill"..i):LockHighlight();
				else
					getglobal("TradeskillInfoSkill"..i):UnlockHighlight();
				end
			end
		else
			skillButton:Hide();
		end
	end

	-- Set the expand/collapse all button texture
	local numHeaders = 0;
	local notExpanded = 0;
	for i=1, numTradeSkills, 1 do
		local skillName, skillType, isExpanded = self:GetTradeSkillInfo(i);
		if ( skillName and skillType == "header" ) then
			numHeaders = numHeaders + 1;
			if ( not isExpanded ) then
				notExpanded = notExpanded + 1;
			end
		end
	end
	-- If all headers are not expanded then show collapse button, otherwise show the expand button
	if ( notExpanded ~= numHeaders ) then
		TradeskillInfoCollapseAllButton.collapsed = nil;
		TradeskillInfoCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
	else
		TradeskillInfoCollapseAllButton.collapsed = 1;
		TradeskillInfoCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
	end
end

----------------------------------------------------------------------
--- Draw selected tradeskill info. Item + reagents
----------------------------------------------------------------------
function TradeskillInfoUI:Frame_SetSelection(id)
	if ( id > self:GetNumTradeSkills() ) then
		return;
	end
	if id == 0 then
		TradeskillInfoSkillName:Hide();
		TradeskillInfoSkillIcon:Hide();
		TradeskillInfoSkillIcon.tooltip = nil;
		TradeskillInfoSkillIcon.known = nil;
		TradeskillInfoSkillIcon.link = nil;
		TradeskillInfoSkillIcon.name = nil;
		TradeskillInfoRequirementLabel:Hide();
		TradeskillInfoRequirementText:SetText("");
		TradeskillInfoDescription:SetText("");
		TradeskillInfoRecipe:SetText("");
		TradeskillInfoKnown:SetText("");
		for i=1, TradeskillInfoUI.cons.maxSkillReagents, 1 do
			local reagent = getglobal("TradeskillInfoReagent"..i);
			reagent:Hide();
			reagent.tooltip = nil;
			reagent.known = nil;
			reagent.link = nil;
			reagent.name = nil;
		end
		return;
	end
	local skillName, skillType, isExpanded = self:GetTradeSkillInfo(id);
	TradeskillInfoHighlightFrame:Show();
	if ( skillType == "header" ) then
		TradeskillInfoHighlightFrame:Hide();
		if ( isExpanded ) then
			self:CollapseHeader(id);
		else
			self:ExpandHeader(id);
		end
		return;
	end
	self.vars.selectionIndex = id;
	skillType = self:GetTradeSkillAvailability(id);
	local color = self.vars.TradeSkillTypeColor[skillType];
	if ( color ) then
		TradeskillInfoHighlight:SetVertexColor(color.r, color.g, color.b);
	end

	TradeskillInfoSkillName:SetText(skillName);
	TradeskillInfoSkillName:Show();
	local skillTexture,skillLink,skillItemString = self:GetTradeSkillIcon(id)
	TradeskillInfoSkillIcon:SetNormalTexture(skillTexture);
	TradeskillInfoSkillIcon.tooltip = skillItemString;
	TradeskillInfoSkillIcon.known = skillLink ~= nil;
	TradeskillInfoSkillIcon.link = skillLink;
	TradeskillInfoSkillIcon.name = skillName;
	TradeskillInfoSkillIcon:Show();

	local numMade = self:GetTradeSkillNumMade(id);
	if numMade then
		TradeskillInfoSkillIconCount:SetText(numMade);
	else
		TradeskillInfoSkillIconCount:SetText("");
	end
			
	local skill,spec,level = self:GetTradeSkillSkillLevel(id)
	local skillName = self:GetTradeSkillName(skill);
	local specName = self:GetTradeSkillSpecializationName(spec);
	TradeskillInfoRequirementLabel:Show();
	if specName then
		TradeskillInfoRequirementText:SetText(skillName.."("..level.."), "..specName);
	else		
		TradeskillInfoRequirementText:SetText(skillName.."("..level..")");
	end

	local skillDescription = self:GetTradeSkillDescription(id);
	if skillDescription then
		TradeskillInfoDescription:SetText(skillDescription);
	else
		TradeskillInfoDescription:SetText("");
	end
	
	local skillSource = self:GetTradeSkillRecipe(id);
	if skillSource then
		TradeskillInfoRecipe:SetText(skillSource);
	else
		TradeskillInfoRecipe:SetText("");
	end
	
	local skillAvailable = self:GetTradeSkillBy(id);
	if skillAvailable then
		TradeskillInfoKnown:SetText(skillAvailable);
	else
		TradeskillInfoKnown:SetText("");
	end
		
	-- Reagents
	local numReagents = self:GetTradeSkillNumReagents(id);
	for i=1, numReagents, 1 do
		local reagentName, reagentTexture, reagentCount, reagentLink, reagentItemString = self:GetTradeSkillReagentInfo(i);
		local reagent = getglobal("TradeskillInfoReagent"..i)
		local name = getglobal("TradeskillInfoReagent"..i.."Name");
		local count = getglobal("TradeskillInfoReagent"..i.."Count");
		if ( not reagentName or not reagentTexture ) then
			reagent:Hide();
		else
			reagent:Show();
			SetItemButtonTexture(reagent, reagentTexture);
			reagent.tooltip = reagentItemString;
			reagent.known = reagentLink ~= nil;
			reagent.link = reagentLink;
			reagent.name = reagentName;
			name:SetText(reagentName);
			SetItemButtonTextureVertexColor(reagent, 1.0, 1.0, 1.0);
			name:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
			count:SetText(reagentCount);
		end
	end
	
	for i=numReagents + 1, TradeskillInfoUI.cons.maxSkillReagents, 1 do
		local reagent = getglobal("TradeskillInfoReagent"..i);
		reagent:Hide();
		reagent.tooltip = nil;
		reagent.known = nil;
		reagent.link = nil;
		reagent.name = nil;
	end

	-- Fix for Enchants. Show tooltip if all reagents are known
	if skillLink == nil and
		self:IsSafeToShowTooltip(id) then
		TradeskillInfoSkillIcon.known = true;
	end
			
end

----------------------------------------------------------------------
--- Called after a forced item lookup to update icons
----------------------------------------------------------------------
function TradeskillInfoUI:Frame_Refresh()
	self:Frame_SetSelection(self.vars.selectionIndex);
end

----------------------------------------------------------------------
--- Clicked tradeskill name
----------------------------------------------------------------------
function TradeskillInfoUI:SkillButton_OnClick(button)
	if ( button == "LeftButton" ) then
		self:Frame_SetSelection(this:GetID());
		self:Frame_Update();
	end
end

----------------------------------------------------------------------
--- Click on item or reagent icon
----------------------------------------------------------------------
function TradeskillInfoUI:ReagentIcon_OnClick(this)
	if ( IsControlKeyDown() ) then
		DressUpItemLink(this.tooltip);
	elseif ( IsShiftKeyDown() ) then
		if ( ChatFrameEditBox:IsVisible() ) then
			if this.known then
				ChatFrameEditBox:Insert(this.link);
			else
				ChatFrameEditBox:Insert(this.name);
			end
		end
	else
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
		GameTooltip:SetHyperlink(this.tooltip);
		self:ScheduleEvent(self.Frame_Refresh, 1, self);
	end
end
					
----------------------------------------------------------------------
--- Show Reagent or Item tooltip on mouse over
----------------------------------------------------------------------
function TradeskillInfoUI:ShowReagentTooltip(this)
	if this.known then
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
		GameTooltip:SetHyperlink(this.tooltip);
		CursorUpdate();
	else
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
		GameTooltip:SetText(this.name);
		GameTooltip:AddLine(L["Item not in local cache."]);
		GameTooltip:AddLine(L["Click to try to update local cache."]);
		GameTooltip:AddLine(L["Warning! You can be disconnected."]);
		GameTooltip:Show();
	end
end

function TradeskillInfoUI:CollapseAllButton_OnClick()
	if (this.collapsed) then
		this.collapsed = nil;
		self:ExpandHeader(0);
	else
		this.collapsed = true;
		TradeskillInfoListScrollFrameScrollBar:SetValue(0);
		self:CollapseHeader(0);
	end
end

----------------------------------------------------------------------
--- Availablity Drop Down Menu functions
----------------------------------------------------------------------
function TradeskillInfoUI:AvailabilityDropDown_OnLoad()
	UIDropDownMenu_SetWidth(120);
	UIDropDownMenu_SetText(L["Availability"], TradeskillInfoAvailabilityDropDown);
end

function TradeskillInfoUI:AvailabilityDropDown_OnShow()
	UIDropDownMenu_Initialize(this, TradeskillInfoUI.AvailabilityDropDown_Initialize);
	UIDropDownMenu_SetText(L["Availability"], TradeskillInfoAvailabilityDropDown);
end

function TradeskillInfoUI.AvailabilityDropDown_Initialize()
	local self = TradeskillInfoUI;
	local info = {};
	for i,n in pairs(self.vars.availability) do
		info.text = n;
		info.value = i;
		info.checked = self.db.profile.availability[i];
		info.keepShownOnClick = 1;
		info.func = self.AvailabilityDropDown_OnClick;
		info.arg1 = self;
		info.arg2 = i;
		UIDropDownMenu_AddButton(info);
	end
end

function TradeskillInfoUI:AvailabilityDropDown_OnClick(val)
	self.db.profile.availability[val] = not self.db.profile.availability[val];
	self:TriggerEvent("TradeskillInfo_Update");
end

----------------------------------------------------------------------
--- Tradeskills Drop Down Menu functions
----------------------------------------------------------------------
function TradeskillInfoUI:TradeskillsDropDown_OnLoad()
	UIDropDownMenu_SetWidth(120);
	UIDropDownMenu_SetText(L["Tradeskills"], TradeskillInfoTradeskillsDropDown);
end

function TradeskillInfoUI:TradeskillsDropDown_OnShow()
	UIDropDownMenu_Initialize(this, TradeskillInfoUI.TradeskillsDropDown_Initialize);
	UIDropDownMenu_SetText(L["Tradeskills"], TradeskillInfoTradeskillsDropDown);
end

function TradeskillInfoUI.TradeskillsDropDown_Initialize()
	local self = TradeskillInfoUI;
	local info = {};
	for i,n in pairs(TradeskillInfo.vars.tradeskills) do
		info.text = n;
		info.value = i;
		info.checked = self.db.profile.tradeskills[i];
		info.keepShownOnClick = 1;
		info.func = self.TradeskillsDropDown_OnClick;
		info.arg1 = self;
		info.arg2 = i;
		UIDropDownMenu_AddButton(info);
	end
end

function TradeskillInfoUI:TradeskillsDropDown_OnClick(val)
	self.db.profile.tradeskills[val] = not self.db.profile.tradeskills[val];
	self:TriggerEvent("TradeskillInfo_Update");
end

----------------------------------------------------------------------
--- Search Button
----------------------------------------------------------------------
function TradeskillInfoUI:Search_OnClick()
	self:TriggerEvent("TradeskillInfo_Update");
end

----------------------------------------------------------------------
--- UI support functions
----------------------------------------------------------------------

function TradeskillInfoUI:Search()
	local oldSelection = self.vars.searchResult[self.vars.selectionIndex];
	local searchText = TradeskillInfoInputBox:GetText();
	local foundSkills = Compost:Acquire();
	
	self.vars.searchresult = Compost:Erase(self.vars.searchResult);
--	for s,v in pairs(self.db.profile.tradeskills) do
--		if v then 
--			table.insert(self.vars.searchResult,s);
--		end
--	end
	for i in pairs(TradeskillInfo.vars.combines) do
		local skill = TradeskillInfo:GetCombineSkill(i);
		if self.db.profile.tradeskills[skill] then
			local player,alt = TradeskillInfo:GetCombineAvailability(i);
			if (self.db.profile.availability[1] and player==1) or
				 (self.db.profile.availability[2] and player==2) or
				 (self.db.profile.availability[3] and player==3) or
				 (self.db.profile.availability[4] and alt==1) or
				 (self.db.profile.availability[5] and alt==2) or
				 (self.db.profile.availability[6] and alt==3) or
				 (self.db.profile.availability[7] and player==0 and alt==0) then
				local found = true;
				if searchText ~= "" then
					found = false;
					skillName = TradeskillInfo:GetCombineName(i);
					if string.find(skillName, searchText) then
						found = true;
					end
					local components = TradeskillInfo:GetCombineComponents(i);
					for _,c in ipairs(components) do
						if string.find(c.name, searchText) then
							found = true;
							break;
						end
					end
					Compost:Reclaim(components, 2);
				end
				if found then	
					if not foundSkills[skill] then
						foundSkills[skill] = true;
						table.insert(self.vars.searchResult, skill);
					end
					if self.db.profile.expanded[skill] then
						table.insert(self.vars.searchResult, i);
					end
				end
			end
		end
	end
	Compost:Reclaim(foundSkills);
	
	table.sort(self.vars.searchResult, function(a,b)
		local as,ap,al,bs,bp,bl;
		if type(a) == "string" then
			as,ap,al = a,"",0;
		else
			as,ap,al = TradeskillInfo:GetCombineSkill(a);
		end
		if type(b) == "string" then
			bs,bp,bl	= b,"",0;
		else
			bs,bp,bl = TradeskillInfo:GetCombineSkill(b);
		end
		if (as < bs) or (as == bs and ap < bp) or (as == bs and ap == bp and al < bl) or (as == bs and ap == bp and al == bl and a < b) then 
			return true
		end
		return false
	end);
	
	self.vars.selectionIndex = 0;
	if oldSelection then
		for i,v in ipairs(self.vars.searchResult) do
			if v == oldSelection then
				self.vars.selectionIndex = i;
				break;
			end
		end
	end
	if self.vars.selectionIndex == 0 then
		self.vars.selectionIndex = self:GetFirstTradeSkill();
	end
end

function TradeskillInfoUI:SetSearchText(text)
	TradeskillInfoInputBox:SetText(text);
end

function TradeskillInfoUI:GetNumTradeSkills()
	return table.getn(self.vars.searchResult);
end

function TradeskillInfoUI:GetFirstTradeSkill()
	for i,s in ipairs(self.vars.searchResult) do
		if type(s) ~= "string" then
			return i;
		end
	end
	return 0;
end

function TradeskillInfoUI:GetTradeSkillInfo(index)
	if not self.vars.searchResult[index] then return end
	local skillName
	if type(self.vars.searchResult[index]) == "string" then
		skillName = TradeskillInfo.vars.tradeskills[self.vars.searchResult[index]];
		local isExpanded = self.db.profile.expanded[self.vars.searchResult[index]];
		return skillName, "header", isExpanded;
	end
	skillName = TradeskillInfo:GetCombineName(self.vars.searchResult[index]);
	return skillName, "combine", true;
end

function TradeskillInfoUI:GetTradeSkillDescription(index)
	if not self.vars.searchResult[index] then return end
	return TradeskillInfo:GetCombineDescription(self.vars.searchResult[index]);
end

function TradeskillInfoUI:GetTradeSkillNumMade(index)
	if not self.vars.searchResult[index] then return end
	return TradeskillInfo:GetCombineYield(self.vars.searchResult[index]);
end

function TradeskillInfoUI:GetTradeSkillAvailability(index)
	if not self.vars.searchResult[index] then return end
	local skillType
	if type(self.vars.searchResult[index]) == "string" then
		return "header";
	end
	local player,alt = TradeskillInfo:GetCombineAvailability(self.vars.searchResult[index]);
	if player > 0 then
		skillType = player == 1 and "playerknown" or player == 2 and "playerlearn" or player == 3 and "playerhigh";
	elseif alt > 0 then
		skillType = alt == 1 and "altknown" or alt == 2 and "altlearn" or alt == 3 and "althigh";
	else
		skillType = "unavailable";
	end
	return skillType;
end

function TradeskillInfoUI:GetTradeSkillRecipe(index)
	if not self.vars.searchResult[index] then return end
	local text
	local id = TradeskillInfo:GetCombineRecipe(self.vars.searchResult[index]);
	if id then
		local sources = TradeskillInfo:GetRecipeSources(id);
		if sources then
			text = L["Recipe: "]..sources;
		end
	end
	return text;
end

function TradeskillInfoUI:GetTradeSkillBy(index)
	local knownBy = TradeskillInfo:GetCombineKnownBy(self.vars.searchResult[index]);
	local learnableBy = TradeskillInfo:GetCombineLearnableBy(self.vars.searchResult[index]);
	local availableTo = TradeskillInfo:GetCombineAvailableTo(self.vars.searchResult[index]);
	local text
	if knownBy then
		text = "|Cffffffff"..L["Known By: "]..knownBy.."|r";
	end
	if learnableBy then
		if not text then
			text = "|Cff33ff33"..L["Learnable By: "]..learnableBy.."|r";
		else
			text = text.."\n|cff33ff33"..L["Learnable By: "]..learnableBy.."|r";
		end
	end
	if availableTo then
		if not text then
			text = "|Cffff7733"..L["Will Be Learnable By: "]..availableTo.."|r";
		else
			text = text.."\n|Cffff7733"..L["Will Be Learnable By: "]..availableTo.."|r"
		end
	end
	return text;
end

function TradeskillInfoUI:GetTradeSkillIcon(index)
	if not self.vars.searchResult[index] then return end
	return TradeskillInfo:GetCombineTexture(self.vars.searchResult[index])
end

	
function TradeskillInfoUI:GetTradeSkillNumReagents(index)
	if self.vars.components then 
		Compost:Reclaim(self.vars.components,2);
		self.vars.components = nil;
	end
	if not self.vars.searchResult[index] then return end
	self.vars.components = TradeskillInfo:GetCombineComponents(self.vars.searchResult[index])
	return table.getn(self.vars.components);
end

function TradeskillInfoUI:GetTradeSkillReagentInfo(i)
	if not self.vars.components[i] then return end
	return self.vars.components[i].name, self.vars.components[i].texture, self.vars.components[i].num, self.vars.components[i].link, self.vars.components[i].itemString;
end

function TradeskillInfoUI:IsSafeToShowTooltip(index)
	local known = true;
	if self.vars.searchResult[index] < 0 then
		for i,c in ipairs(self.vars.components) do
			if not c.link then
				known = false;
			end
		end
	end
	return known;
end
	
		
function TradeskillInfoUI:GetTradeSkillSkillLevel(index)
	return TradeskillInfo:GetCombineSkill(self.vars.searchResult[index]);
end

function TradeskillInfoUI:GetTradeSkillName(skill)
	return TradeskillInfo.vars.tradeskills[skill];
end

function TradeskillInfoUI:GetTradeSkillSpecializationName(spec)
	return TradeskillInfo.vars.specializations[spec];
end

function TradeskillInfoUI:CollapseHeader(index)
	if self.vars.searchResult[index] and type(self.vars.searchResult[index]) == "string" then
		self.db.profile.expanded[self.vars.searchResult[index]] = false;
		self:TriggerEvent("TradeskillInfo_Update");
	elseif index == 0 then
		for i,_ in pairs(self.db.profile.expanded) do
			self.db.profile.expanded[i] = false;
		end
		self:TriggerEvent("TradeskillInfo_Update");
	end
end

function TradeskillInfoUI:ExpandHeader(index)
	if self.vars.searchResult[index] and type(self.vars.searchResult[index]) == "string" then
		self.db.profile.expanded[self.vars.searchResult[index]] = true;
		self:TriggerEvent("TradeskillInfo_Update");
	elseif index == 0 then
		for i,_ in pairs(self.db.profile.expanded) do
			self.db.profile.expanded[i] = true;
		end
		self:TriggerEvent("TradeskillInfo_Update");
	end
end

--[[
TradeskillInfoSkillButtonTemplate
TradeskillInfoItemTemplate
TradeskillInfoButtonTemplate
TradeskillInfoListScrollFrameTemplate

TradeskillInfoFrame
	TradeskillInfoFrameTitleText
	
	TradeskillInfoListFrame
		TradeskillInfoCollapseAllButton
		TradeskillInfoAvailabilityDropDown
		TradeskillInfoTradeskillsDropDown
		TradeskillInfoHighlightFrame
		TradeskillInfoSkill1
		TradeskillInfoSkill2
		TradeskillInfoSkill3
		TradeskillInfoSkill4
		TradeskillInfoSkill5
		TradeskillInfoSkill6
		TradeskillInfoSkill7
		TradeskillInfoSkill8
		TradeskillInfoSkill9
		TradeskillInfoSkill10
		TradeskillInfoSkill11
		TradeskillInfoSkill12
		TradeskillInfoSkill13
		TradeskillInfoSkill14
		TradeskillInfoSkill15
		TradeskillInfoSkill16
		TradeskillInfoListScrollFrame
	
	TradeskillInfoDetailFrame
		TradeskillInfoSkillName
		TradeskillInfoRequirementLabel
		TradeskillInfoRequirementText
		
		TradeskillInfoDescription
		TradeskillInfoRecipe
		TradeskillInfoKnown
		TradeskillInfoReagentLabel
		
		TradeskillInfoSkillIcon
		TradeskillInfoSkillIconCount
		
		TradeskillInfoReagent1
		TradeskillInfoReagent2
		TradeskillInfoReagent3
		TradeskillInfoReagent4
		TradeskillInfoReagent5
		TradeskillInfoReagent6
		TradeskillInfoReagent7
		TradeskillInfoReagent8
	
	TradeskillInfoSearchButton
	TradeskillInfoInputBox
	
	TradeskillInfoFrameCloseButton
]]
	